/// Based on i-Regr, but only draws the value for the current bar at any given time

//----
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 LightSeaGreen
#property indicator_color2 OrangeRed
#property indicator_color3 OrangeRed
#property indicator_color4 Gold

extern int degree = 3;
extern int depth = 60;
extern double deviation = 2.0;
extern int Price = PRICE_CLOSE;

//-----
double pred[],reg[],fx[],sqh[],sql[];

double ai[400,400],b[400],x[400], sx[800];
double sum; 
int n,f;
double qq,mm,tt;
int ii,jj,kk,ll,nn, mi;
double sq;

int SHIFTV=1;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
  SetIndexBuffer(0, reg);
  SetIndexBuffer(1, sqh);
  SetIndexBuffer(2, sql);
  SetIndexBuffer(3, pred);
    
  ArrayResize(fx, depth + 1);

  SetIndexStyle(0, DRAW_LINE);
  SetIndexStyle(1, DRAW_LINE);
  SetIndexStyle(2, DRAW_LINE);
  SetIndexStyle(3, DRAW_LINE);

  SetIndexEmptyValue(0, 0.0);
  SetIndexEmptyValue(1, 0.0);
  SetIndexEmptyValue(2, 0.0);
  SetIndexEmptyValue(3, 0.0);
  
  SetIndexDrawBegin(0, depth);
  SetIndexDrawBegin(1, depth);
  SetIndexDrawBegin(2, depth); 
  SetIndexDrawBegin(3, depth);
  
  nn = degree + 1;
  
  // SumX
  sx[1] = depth + 1;
  for(mi = 1; mi <= degree * 2; mi++)
  {
    sum = 0.0;
    for(n = 0; n <= depth; n++)
    {
       sum += MathPow(n, mi);
    }
    sx[mi + 1] = sum;
  }

  return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
  if (Bars < depth) return(0);
 
  int i, limit, counted = IndicatorCounted(); 
  
  if (counted > nn) limit = Bars - counted;
  else              limit = Bars - nn;

   for (i = limit; i >= 0; i--)
   {
     // SumXY
     for(mi = 1; mi <= nn; mi++)
     {
       sum = 0.0;
       for(n = 0; n <= depth; n++)
       {
          if(mi == 1) sum += getPrice(i + n);
          else sum += getPrice(i + n) * MathPow(n, mi - 1);
       }
       b[mi] = sum;
     }
     // Matrix
      for(jj = 1; jj <= nn; jj++)
      {
        for(ii = 1; ii <= nn; ii++)
        {
           kk = ii + jj - 1;
           ai[ii, jj] = sx[kk];
        }
      } 
 
   //===============Gauss========================================================================================================
     for(kk = 1; kk <= degree; kk++)
     {
       ll = 0;
       mm = 0;
       for(ii = kk; ii <= nn; ii++)
       {
          if (MathAbs(ai[ii, kk]) > mm)
          {
             mm = MathAbs(ai[ii, kk]);
             ll = ii;
          }
       }
       if (ll == 0) return(0);   
       if (ll != kk)
       {
          for(jj = 1; jj <= nn; jj++)
          {
             tt = ai[kk, jj];
             ai[kk, jj] = ai[ll, jj];
             ai[ll, jj] = tt;
          }
          tt = b[kk];
          b[kk] = b[ll];
          b[ll] = tt;
       }  
       for(ii = kk + 1; ii <= nn; ii++)
       {
          qq = ai[ii, kk] / ai[kk, kk];
          for(jj = 1; jj <= nn; jj++)
          {
             if(jj == kk) ai[ii, jj] = 0;
             else ai[ii, jj] = ai[ii, jj] - qq * ai[kk, jj];
          }
          b[ii] = b[ii] - qq * b[kk];
       }
     }
   
     x[nn] = b[nn] / ai[nn, nn];
     for(ii = depth; ii > 0; ii--)
     {
       tt = 0;
       for(jj = 1; jj <= nn - ii; jj++)
       {
          tt = tt + ai[ii, ii + jj] * x[ii + jj];
          x[ii] = (1 / ai[ii, ii]) * (b[ii] - tt);
       }
     } 
   //===========================================================================================================================
  
     for(n = 0; n <= depth; n++)
     {
       sum = 0.0;
       for(kk = 1; kk <= degree; kk++)
       {
          sum += x[kk + 1] * MathPow(n, kk);
       }
       fx[n] = x[1] + sum;
     }
     
     for(n=0;n<=SHIFTV-1;n++)
  {
    sum=0;
    for(kk=1;kk<=degree;kk++)
    {
       sum+=x[kk+1]*MathPow(n-SHIFTV,kk);
    }
    pred[i]=x[1]+sum;
  }   
     
      
   //-----------------------------------Std-----------------------------------------------------------------------------------
     sq = 0.0;
     for(n = 0; n <= depth; n++)
     {
       sq += MathPow(getPrice(i + n) - fx[n], 2);
     }
     sq = MathSqrt(sq / (depth + 1)) * deviation;

     reg[i] = fx[0];
     sqh[i] = fx[0] + sq;
     sql[i] = fx[0] - sq;
   }
  return(0);
}
//+------------------------------------------------------------------+
double getPrice(int i)
{
   switch (Price)
   {
      case 0: return(Close[i]); break;
      case 1: return(Open[i]); break;
      case 2: return(High[i]); break;
      case 3: return(Low[i]); break;
      case 4: return((High[i] + Low[i]) / 2.0); break;
      case 5: return((High[i] + Low[i] + Close[i]) / 3.0); break;
      case 6: return((High[i] + Low[i] + Close[i] * 2) / 4.0); break;
      default: return(Close[i]); break;
   }
}